       program puntsvg
       implicit none
       double precision x0,fi,delta,xms1,deltaesp,P(0:1000,0:1000),l
       integer*4 n,j,k
       double precision wi,f,xp,a,b,cnv,INTEGRAL,t,pres!Pressió a iterar
       double precision vest,pr,ddf,df,indic,meta,dmeta
       double precision pl,pg,rect,tmp,lima,limb,v0
       parameter (deltaesp=1.2d-16)
       
       
       open (1,file="dades6.dat")
           
           
       t=0.90
       call limp (t,pl,pg)
       
       pres=pg
       k=1
       rect=1
       !do k=1,10
       do while (dabs(rect-INTEGRAL).gt.(1d-5))
        pres=pres-0.000001
c--------------------------------------------------------------------------------------------------
c------INTEGRAL---GAUSS-LEGENDRE------INTEGRAL---GAUSS-LEGENDRE------INTEGRAL---GAUSS-LEGENDRE-----
c--------------------------------------------------------------------------------------------------       
        tmp=1       
        n=1 !Nombre de divisions
        
         v0=(1.0/3.0)-0.0000001
         call nr(pres,t,v0,a)
         v0=5
         call nr(pres,t,v0,b)
           !write (*,*) a,pr(t,a)
         do while (dabs(INTEGRAL-tmp).gt.(1.2d-16))
          tmp=INTEGRAL
          l=dble(n)
          INTEGRAL=0
          delta=1
          do j=1,n
           x0=3.14159265358979*(4*dble(j)-1)  !
           x0=x0/(4*l+2)                      !
           x0=dcos(x0)   !___Aproximació de Francesco Tricomi:http://math.stackexchange.com/questions/12160/roots-of-legendre-polynomial
           xp=1.0-(1.0/(8*l*l))               ! per trobar es j-èssim zero d'es polinomi de Legendre d'ordre n, i després afilar amb N-R
           xp=xp+(1.0/(8*l**3))               !
           x0=x0*xp                           !
           delta=1
               do while (delta.ge.deltaesp)  !Newton-Raphson per afilar
                  call legen(n,x0,P) !Trob es valor d'es polinomi de Legendre de grau n per x=x0, juntament amb sa seva derivada
                  xms1=x0-(P(n,0)/P(n,1))
                  delta= dabs(x0-xms1)
                  x0=xms1
               enddo
              
                wi=2/((1-x0*x0)*P(n,1)*P(n,1))
                INTEGRAL=INTEGRAL+(pr(t,cnv(a,b,x0))*wi)  !Suma dels productes de f(ti)*xi que em dona sa integral
                !print *,x0, wi
          enddo
             INTEGRAL=((b-a)/2.0)*INTEGRAL
            n=n+1
         enddo
c-----------------------------------------------------------------------------------------------------------------------
        rect=pres*(b-a)
        !k=k+1
       enddo
       print*,"v*_g=", a," p*_g=",b,pres
           write (1,*) a,pr(t,a)
           write (1,*) b,Pr(t,b)
       
       stop
       end


c---------Generador de polinomis de Legendre----------------------
       
       subroutine legen(i,x,P)
       integer*4 i,l,j
       double precision x,P
       dimension P(0:1000,0:1000) !Matriu on sa 1ª columna em diu es polinomi de Legendre, i sa segona sa corresponent derivada.
       P(0,0)=1.0 !Em defin els primers polinomis i ses respectives derivades.
       P(0,1)=0.0
       P(1,1)=1.0
       P(1,0)=x
       do l=1,i-1,1 !Aplic ses relacions de recurrència per calcular els polinomis i ses derivades (Schaumn)
         P(l+1,0)=((2.0*dble(l)+1.0)*x*P(l,0)-dble(l)*P(l-1,0))/(dble(l)
     ++1.0)
         P(l+1,1)=(l+1)*P(l,0)+x*P(l,1)
       
       enddo
       return
       
       end subroutine


c---------Canvi de variable----------------------

       double precision function cnv(a,b,ti) !Aquesta funció em fa es canvi de variable per fer que els límits d'integració siquin [-1,1]
       double precision a,b,ti
       cnv=(0.5*(b-a)*ti+0.5*(a+b))
       return
       end
       
c---------Funció a trobar zeros-----------      
      double precision function f (t,p,v)
      double precision t,p,v
      f=3.0*p*(v**3.0)-(p+8.0d0*t)*v*v+9.0*v-3
      
      return
      end function f
      

c---------Derivada de sa funció-----------       
      double precision function df (t,p,v)
      double precision t,p,v
      
      df=9*p*v**2-(p+8.0d0*t)*v*2+9
      
       return
       end function df
      

c---------2a derivada de sa funció-----------       
      double precision function ddf (t,p,v)
      double precision t,p,v
      
      ddf=18*p*v-(p+8.0d0*t)*2
      
       return
       end function ddf



c---------Cercador-d'arrels-de sa funció per trobar una v------------------       
       subroutine nr (p,t,x0,v)
       double precision x0, delta,xms1,f,df,ddf,p,t,v
       double precision error
       integer*4 k,i
       parameter (deltaesp=1.2d-12)
       delta=1
       i=1 
       do while ((delta.ge.deltaesp))
        error=delta
        xms1=x0-(f(t,p,x0)/df(t,p,x0))
        delta= dabs(x0-xms1)
        x0=xms1
        
        !print *,t,p,x0,DABS(df(t,p,x0)),DABS(ddf(t,p,x0))
        i=i+1
        if (((dabs(df(t,p,x0))).le.(1.0d-12)))then
          goto 5
        else if ((dabs(ddf(t,p,x0))).le.(1.0d-12)) then ! Si per sort es troba aprop d'un punt d'inflexió, que surti
         goto 5
         
        else if (i.gt.1000) then !En cas de que no funcioni lo de sa 2ª derivada, amb 1000 iteracions crec que hi ha prou
          goto 5
        endif
       enddo
5      v=x0
       return
       end subroutine nr
       
       
       
c-----Límits de metaestabilitat (sa sortida són ses p*)-----------------
      subroutine limp (t,pl,pg)
      double precision pr,t,v0,v,meta,vl,vg,dmeta,pl,pg
      integer*8 i,j
      call indic (t,v0)
      call vest(t,v0,vl)
      pl=pr(t,vl)
       print*,"v*_l=", vl," p*_l=",pl
       
       v0=4
     
       call vest(t,v0,vg)
       pg=pr(t,vg)
       print*,"v*_g=", vg," p*_g=",pg
      end subroutine limp
c---------Funció a trobar zeros (que són ses metaestabiltats)-----------      
      double precision function meta(t,v)
      double precision t,p,v
      meta=4.0*t*(v**3.0)-(9.0)*v*v+6.0*v-1.0d0
      
      return
      end function meta
      
c---------Derivada de sa funció meta-----------       
      double precision function dmeta(t,v)
      double precision t,v
      dmeta=12.0*t*(v**2.0)-(18.0)*v+6.0
      return
      end function dmeta
       
c---------Arrels de sa 2a derivada de sa funció que ens ayuda a trobar els zeros-----------       
      subroutine indic (t,v0)
      double precision t,v0
      v0=(18.0/(24.0*t))
      
      
      return
      end subroutine



      
c-------Troba sa presió a partir d'un volum i d'una temperatura
      double precision function pr (t,v)
      double precision t,v
      
      pr=(8*t/(3.0*v-1.0))
      pr=pr-(3.0/(v*v))
      
       return
       end function pr
      
c---------Cercador-d'arrels-d'una-funció per trobar els limits de metaestabilitat------------------       
       subroutine vest (t,v,x0)
       double precision x0, delta,xms1,meta,dmeta,p,t,v
       double precision error
       integer*4 i
       parameter (deltaesp=1.2d-16)
       delta=1
       i=1
        x0=v
       do while ((delta.ge.deltaesp))
        error=delta
        xms1=x0-(meta(t,x0)/dmeta(t,x0))
        delta= dabs(x0-xms1)
        x0=xms1
        
        i=i+1
       
        if (i.gt.1000) then !En cas de que no funcioni lo de sa 2ª derivada, amb 1000 iteracions crec que hi ha prou
          goto 5
        endif
       enddo
      
5       return
       end subroutine vest       


